# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server.models.arm_brokerage_api_core_v1alpha1_tenant import ArmBrokerageApiCoreV1alpha1Tenant  # noqa: F401,E501
from swagger_server.models.io_k8s_apimachinery_pkg_apis_meta_v1_list_meta import IoK8sApimachineryPkgApisMetaV1ListMeta  # noqa: F401,E501
from swagger_server import util


class ArmBrokerageApiCoreV1alpha1TenantList(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, api_version: str=None, items: List[ArmBrokerageApiCoreV1alpha1Tenant]=None, kind: str=None, metadata: IoK8sApimachineryPkgApisMetaV1ListMeta=None):  # noqa: E501
        """ArmBrokerageApiCoreV1alpha1TenantList - a model defined in Swagger

        :param api_version: The api_version of this ArmBrokerageApiCoreV1alpha1TenantList.  # noqa: E501
        :type api_version: str
        :param items: The items of this ArmBrokerageApiCoreV1alpha1TenantList.  # noqa: E501
        :type items: List[ArmBrokerageApiCoreV1alpha1Tenant]
        :param kind: The kind of this ArmBrokerageApiCoreV1alpha1TenantList.  # noqa: E501
        :type kind: str
        :param metadata: The metadata of this ArmBrokerageApiCoreV1alpha1TenantList.  # noqa: E501
        :type metadata: IoK8sApimachineryPkgApisMetaV1ListMeta
        """
        self.swagger_types = {
            'api_version': str,
            'items': List[ArmBrokerageApiCoreV1alpha1Tenant],
            'kind': str,
            'metadata': IoK8sApimachineryPkgApisMetaV1ListMeta
        }

        self.attribute_map = {
            'api_version': 'apiVersion',
            'items': 'items',
            'kind': 'kind',
            'metadata': 'metadata'
        }
        self._api_version = api_version
        self._items = items
        self._kind = kind
        self._metadata = metadata

    @classmethod
    def from_dict(cls, dikt) -> 'ArmBrokerageApiCoreV1alpha1TenantList':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The armBrokerage.api.core.v1alpha1.TenantList of this ArmBrokerageApiCoreV1alpha1TenantList.  # noqa: E501
        :rtype: ArmBrokerageApiCoreV1alpha1TenantList
        """
        return util.deserialize_model(dikt, cls)

    @property
    def api_version(self) -> str:
        """Gets the api_version of this ArmBrokerageApiCoreV1alpha1TenantList.

        APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources  # noqa: E501

        :return: The api_version of this ArmBrokerageApiCoreV1alpha1TenantList.
        :rtype: str
        """
        return self._api_version

    @api_version.setter
    def api_version(self, api_version: str):
        """Sets the api_version of this ArmBrokerageApiCoreV1alpha1TenantList.

        APIVersion defines the versioned schema of this representation of an object. Servers should convert recognized schemas to the latest internal value, and may reject unrecognized values. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources  # noqa: E501

        :param api_version: The api_version of this ArmBrokerageApiCoreV1alpha1TenantList.
        :type api_version: str
        """

        self._api_version = api_version

    @property
    def items(self) -> List[ArmBrokerageApiCoreV1alpha1Tenant]:
        """Gets the items of this ArmBrokerageApiCoreV1alpha1TenantList.

        List of tenants  # noqa: E501

        :return: The items of this ArmBrokerageApiCoreV1alpha1TenantList.
        :rtype: List[ArmBrokerageApiCoreV1alpha1Tenant]
        """
        return self._items

    @items.setter
    def items(self, items: List[ArmBrokerageApiCoreV1alpha1Tenant]):
        """Sets the items of this ArmBrokerageApiCoreV1alpha1TenantList.

        List of tenants  # noqa: E501

        :param items: The items of this ArmBrokerageApiCoreV1alpha1TenantList.
        :type items: List[ArmBrokerageApiCoreV1alpha1Tenant]
        """
        if items is None:
            raise ValueError("Invalid value for `items`, must not be `None`")  # noqa: E501

        self._items = items

    @property
    def kind(self) -> str:
        """Gets the kind of this ArmBrokerageApiCoreV1alpha1TenantList.

        Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds  # noqa: E501

        :return: The kind of this ArmBrokerageApiCoreV1alpha1TenantList.
        :rtype: str
        """
        return self._kind

    @kind.setter
    def kind(self, kind: str):
        """Sets the kind of this ArmBrokerageApiCoreV1alpha1TenantList.

        Kind is a string value representing the REST resource this object represents. Servers may infer this from the endpoint the client submits requests to. Cannot be updated. In CamelCase. More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds  # noqa: E501

        :param kind: The kind of this ArmBrokerageApiCoreV1alpha1TenantList.
        :type kind: str
        """

        self._kind = kind

    @property
    def metadata(self) -> IoK8sApimachineryPkgApisMetaV1ListMeta:
        """Gets the metadata of this ArmBrokerageApiCoreV1alpha1TenantList.


        :return: The metadata of this ArmBrokerageApiCoreV1alpha1TenantList.
        :rtype: IoK8sApimachineryPkgApisMetaV1ListMeta
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata: IoK8sApimachineryPkgApisMetaV1ListMeta):
        """Sets the metadata of this ArmBrokerageApiCoreV1alpha1TenantList.


        :param metadata: The metadata of this ArmBrokerageApiCoreV1alpha1TenantList.
        :type metadata: IoK8sApimachineryPkgApisMetaV1ListMeta
        """

        self._metadata = metadata
